function [UnconditionalWelfare,ConditionalWelfare]=LooseCommitmentWelfare(Y_Mu_0,v)%,ReConvexify

[H,G,A0,Alead,Alag,B,iGAM0,W,SIGv,beta,gam]=GetDynareLooseCommitmentResults;

[mult_nbr,endo_nbr]=size(A0);
exo_nbr=size(B,2);
m=mult_nbr+endo_nbr;

if nargin==1
	v=zeros(exo_nbr,1);
elseif nargin==0
	Y_Mu_0=zeros(m,1);
	v=zeros(exo_nbr,1);
elseif nargin<1 ||nargin>3
	error([mfilename,':: Wrong number of inputs'])
end
if ~isequal(size(Y_Mu_0),[m,1])
	error([mfilename,':: First input size expected to be [',int2str(m),',',int2str(1),']'])
end

if ~isequal(size(v),[exo_nbr,1])
	error([mfilename,':: Second input size expected to be [',int2str(exo_nbr),',',int2str(1),']'])
end

y=1:endo_nbr;
l=endo_nbr+1:m;

% Calculating correction factor
temp_corrector = H*Y_Mu_0+G*v;
y_corrector = temp_corrector(y);
correction =1/beta*transpose(Y_Mu_0(l))*Alead*y_corrector;

temp_corrector_Uncond = H*Y_Mu_0;
y_corrector_Uncond = temp_corrector_Uncond(y);
correction_Uncond =1/beta*transpose(Y_Mu_0(l))*Alead*y_corrector_Uncond;

P=zeros(m);
P(y,l)=transpose(Alag);
P(l,y)=1/beta*Alead;
P=.5*P*H;

V0=[W,zeros(endo_nbr,mult_nbr)
  A0+(1-gam)*Alead*H(y,y),zeros(mult_nbr)];

V1=zeros(m);
V1(y,y)=eye(endo_nbr);
V=V0+beta*(1-gam)*transpose(V1)*P*V1+beta*gam*P;

d0=[zeros(endo_nbr,exo_nbr);B];
d=1/(1-beta)*trace(SIGv*(transpose(G)*(V*G+d0)));

UnconditionalWelfare=transpose(Y_Mu_0)*P*Y_Mu_0+d-correction_Uncond;

Y_Mu_1=H*Y_Mu_0+G*v;

ConditionalWelfare=[zeros(endo_nbr),1/beta*transpose(Alead)
                    Alag,zeros(mult_nbr)];
ConditionalWelfare=transpose(Y_Mu_1)*(V*Y_Mu_1+ConditionalWelfare*Y_Mu_0+d0*v)+beta*d-correction;
