% Loose Commitment in Medium- and Large-Scale Models (Debortoli, Maih, Nunes, 2010)
% Copyright: Debortoli, Maih, Nunes (2010). This version, November 2010
% Feel free to use and modify this code at your own risk.

% This files shows some tables of statistices
% INPUTs: - stats cell-array of statistics. The dimensions are {degree of commitment}{variables}(periods)
%         - VARNAMES: labels for the variables
%         - show_var: vector with ones for the variables to show
%         - probCOM_grad: vector with the grid of commitment values (to first row of the table)

function show_tables(stats,VARNAMES,probCOMgrad, show_var)

nseries = size(stats{1},2);
nits_probCOM = length(probCOMgrad);
TABLE = zeros(nseries,nits_probCOM);

for i=1:nseries;
        for j=1:nits_probCOM
            TABLE(i,j)= stats{j}{i}(end);
        end
end

disp('--------------------------------------- ');
disp(strcat(['Variable   ' num2str(probCOMgrad,'%10.3f')]));
disp('--------------------------------------- ');
disp( [VARNAMES(show_var,:)  num2str(TABLE(logical(show_var),:),'%10.3f')] );
disp('---------------------------------------- ');



